SDL_sensor.h File Reference
`#include <SDL3/SDL_stdinc.h>`
`#include <SDL3/SDL_error.h>`
`#include <SDL3/SDL_properties.h>`
`#include <SDL3/SDL_begin_code.h>`
`#include <SDL3/SDL_close_code.h>`
Include dependency graph for SDL_sensor.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Macros

#define | SDL_STANDARD_GRAVITY 9.80665f

## Typedefs

typedef struct SDL_Sensor | SDL_Sensor
typedef Uint32 | SDL_SensorID

## Enumerations

enum | SDL_SensorType { SDL_SENSOR_INVALID = -1 , SDL_SENSOR_UNKNOWN , SDL_SENSOR_ACCEL , SDL_SENSOR_GYRO , SDL_SENSOR_ACCEL_L , SDL_SENSOR_GYRO_L , SDL_SENSOR_ACCEL_R , SDL_SENSOR_GYRO_R , SDL_SENSOR_COUNT }

## Functions

SDL_SensorID * | SDL_GetSensors (int *count)
const char * | SDL_GetSensorNameForID (SDL_SensorID instance_id)
SDL_SensorType | SDL_GetSensorTypeForID (SDL_SensorID instance_id)
int | SDL_GetSensorNonPortableTypeForID (SDL_SensorID instance_id)
SDL_Sensor * | SDL_OpenSensor (SDL_SensorID instance_id)
SDL_Sensor * | SDL_GetSensorFromID (SDL_SensorID instance_id)
SDL_PropertiesID | SDL_GetSensorProperties (SDL_Sensor *sensor)
const char * | SDL_GetSensorName (SDL_Sensor *sensor)
SDL_SensorType | SDL_GetSensorType (SDL_Sensor *sensor)
int | SDL_GetSensorNonPortableType (SDL_Sensor *sensor)
SDL_SensorID | SDL_GetSensorID (SDL_Sensor *sensor)
bool | SDL_GetSensorData (SDL_Sensor *sensor, float *data, int num_values)
void | SDL_CloseSensor (SDL_Sensor *sensor)
void | SDL_UpdateSensors (void)

## Macro Definition Documentation

## SDL_STANDARD_GRAVITY

#define SDL_STANDARD_GRAVITY 9.80665f

A constant to represent standard gravity for accelerometer sensors.

The accelerometer returns the current acceleration in SI meters per second squared. This measurement includes the force of gravity, so a device at rest will have an value of SDL_STANDARD_GRAVITY away from the center of the earth, which is a positive Y value.

Since
  This macro is available since SDL 3.2.0.

Definition at line 76 of file SDL_sensor.h.

## Typedef Documentation

## SDL_Sensor

typedef struct SDL_Sensor SDL_Sensor

# CategorySensor

SDL sensor management.

These APIs grant access to gyros and accelerometers on various platforms.

In order to use these functions, SDL_Init() must have been called with the SDL_INIT_SENSOR flag. This causes SDL to scan the system for sensors, and load appropriate drivers. The opaque structure used to identify an opened SDL sensor.

Since
  This struct is available since SDL 3.2.0.

Definition at line 54 of file SDL_sensor.h.

## SDL_SensorID

typedef Uint32 SDL_SensorID

This is a unique ID for a sensor for the time it is connected to the system, and is never reused for the lifetime of the application.

The value 0 is an invalid ID.

Since
  This datatype is available since SDL 3.2.0.

Definition at line 64 of file SDL_sensor.h.

## Enumeration Type Documentation

## SDL_SensorType

enum SDL_SensorType

The different sensors defined by SDL.

Additional sensors may be available, using platform dependent semantics.

Here are the additional Android sensors:

https://developer.android.com/reference/android/hardware/SensorEvent.html#values

Accelerometer sensor notes:

The accelerometer returns the current acceleration in SI meters per second squared. This measurement includes the force of gravity, so a device at rest will have an value of SDL_STANDARD_GRAVITY away from the center of the earth, which is a positive Y value.

- values[0]: Acceleration on the x axis
- values[1]: Acceleration on the y axis
- values[2]: Acceleration on the z axis

For phones and tablets held in natural orientation and game controllers held in front of you, the axes are defined as follows:

- -X ... +X : left ... right
- -Y ... +Y : bottom ... top
- -Z ... +Z : farther ... closer

The accelerometer axis data is not changed when the device is rotated.

Gyroscope sensor notes:

The gyroscope returns the current rate of rotation in radians per second. The rotation is positive in the counter-clockwise direction. That is, an observer looking from a positive location on one of the axes would see positive rotation on that axis when it appeared to be rotating counter-clockwise.

- values[0]: Angular speed around the x axis (pitch)
- values[1]: Angular speed around the y axis (yaw)
- values[2]: Angular speed around the z axis (roll)

For phones and tablets held in natural orientation and game controllers held in front of you, the axes are defined as follows:

- -X ... +X : left ... right
- -Y ... +Y : bottom ... top
- -Z ... +Z : farther ... closer

The gyroscope axis data is not changed when the device is rotated.

Since
  This enum is available since SDL 3.2.0.

See also
  SDL_GetCurrentDisplayOrientation

Enumerator
SDL_SENSOR_INVALID | Returned for an invalid sensor
SDL_SENSOR_UNKNOWN | Unknown sensor type
SDL_SENSOR_ACCEL | Accelerometer
SDL_SENSOR_GYRO | Gyroscope
SDL_SENSOR_ACCEL_L | Accelerometer for left Joy-Con controller and Wii nunchuk
SDL_SENSOR_GYRO_L | Gyroscope for left Joy-Con controller
SDL_SENSOR_ACCEL_R | Accelerometer for right Joy-Con controller
SDL_SENSOR_GYRO_R | Gyroscope for right Joy-Con controller
SDL_SENSOR_COUNT |

Definition at line 132 of file SDL_sensor.h.

{
SDL_SENSOR_INVALID = -1, /**< Returned for an invalid sensor */
SDL_SENSOR_UNKNOWN, /**< Unknown sensor type */
SDL_SENSOR_ACCEL, /**< Accelerometer */
SDL_SENSOR_GYRO, /**< Gyroscope */
SDL_SENSOR_ACCEL_L, /**< Accelerometer for left Joy-Con controller and Wii nunchuk */
SDL_SENSOR_GYRO_L, /**< Gyroscope for left Joy-Con controller */
SDL_SENSOR_ACCEL_R, /**< Accelerometer for right Joy-Con controller */
SDL_SENSOR_GYRO_R, /**< Gyroscope for right Joy-Con controller */
SDL_SENSOR_COUNT
} SDL_SensorType;
SDL_SensorType
SDL_SensorType
Definition SDL_sensor.h:133
SDL_SENSOR_GYRO_L
@ SDL_SENSOR_GYRO_L
Definition SDL_sensor.h:139
SDL_SENSOR_INVALID
@ SDL_SENSOR_INVALID
Definition SDL_sensor.h:134
SDL_SENSOR_GYRO
@ SDL_SENSOR_GYRO
Definition SDL_sensor.h:137
SDL_SENSOR_ACCEL_R
@ SDL_SENSOR_ACCEL_R
Definition SDL_sensor.h:140
SDL_SENSOR_UNKNOWN
@ SDL_SENSOR_UNKNOWN
Definition SDL_sensor.h:135
SDL_SENSOR_ACCEL
@ SDL_SENSOR_ACCEL
Definition SDL_sensor.h:136
SDL_SENSOR_COUNT
@ SDL_SENSOR_COUNT
Definition SDL_sensor.h:142
SDL_SENSOR_ACCEL_L
@ SDL_SENSOR_ACCEL_L
Definition SDL_sensor.h:138
SDL_SENSOR_GYRO_R
@ SDL_SENSOR_GYRO_R
Definition SDL_sensor.h:141

## Function Documentation

## SDL_CloseSensor()

void SDL_CloseSensor | ( | SDL_Sensor * | sensor | ) |

extern

Close a sensor previously opened with SDL_OpenSensor().

Parameters

  sensor | the SDL_Sensor object to close.

Since
  This function is available since SDL 3.2.0.

## SDL_GetSensorData()

bool SDL_GetSensorData | ( | SDL_Sensor * | sensor,
|  | float * | data,
|  | int | num_values )

extern

Get the current state of an opened sensor.

The number of values and interpretation of the data is sensor dependent.

Parameters

  sensor | the SDL_Sensor object to query.
  data | a pointer filled with the current sensor state.
  num_values | the number of values to write to data.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 3.2.0.

## SDL_GetSensorFromID()

SDL_Sensor * SDL_GetSensorFromID | ( | SDL_SensorID | instance_id | ) |

extern

Return the SDL_Sensor associated with an instance ID.

Parameters

  instance_id | the sensor instance ID.

Returns
  an SDL_Sensor object or NULL on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 3.2.0.

## SDL_GetSensorID()

SDL_SensorID SDL_GetSensorID | ( | SDL_Sensor * | sensor | ) |

extern

Get the instance ID of a sensor.

Parameters

  sensor | the SDL_Sensor object to inspect.

Returns
  the sensor instance ID, or 0 on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 3.2.0.

## SDL_GetSensorName()

const char * SDL_GetSensorName | ( | SDL_Sensor * | sensor | ) |

extern

Get the implementation dependent name of a sensor.

Parameters

  sensor | the SDL_Sensor object.

Returns
  the sensor name or NULL on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 3.2.0.

## SDL_GetSensorNameForID()

const char * SDL_GetSensorNameForID | ( | SDL_SensorID | instance_id | ) |

extern

Get the implementation dependent name of a sensor.

This can be called before any sensors are opened.

Parameters

  instance_id | the sensor instance ID.

Returns
  the sensor name, or NULL if instance_id is not valid.

Since
  This function is available since SDL 3.2.0.

## SDL_GetSensorNonPortableType()

int SDL_GetSensorNonPortableType | ( | SDL_Sensor * | sensor | ) |

extern

Get the platform dependent type of a sensor.

Parameters

  sensor | the SDL_Sensor object to inspect.

Returns
  the sensor platform dependent type, or -1 if sensor is NULL.

Since
  This function is available since SDL 3.2.0.

## SDL_GetSensorNonPortableTypeForID()

int SDL_GetSensorNonPortableTypeForID | ( | SDL_SensorID | instance_id | ) |

extern

Get the platform dependent type of a sensor.

This can be called before any sensors are opened.

Parameters

  instance_id | the sensor instance ID.

Returns
  the sensor platform dependent type, or -1 if instance_id is not valid.

Since
  This function is available since SDL 3.2.0.

## SDL_GetSensorProperties()

SDL_PropertiesID SDL_GetSensorProperties | ( | SDL_Sensor * | sensor | ) |

extern

Get the properties associated with a sensor.

Parameters

  sensor | the SDL_Sensor object.

Returns
  a valid property ID on success or 0 on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 3.2.0.

## SDL_GetSensors()

SDL_SensorID * SDL_GetSensors | ( | int * | count | ) |

extern

Get a list of currently connected sensors.

Parameters

  count | a pointer filled in with the number of sensors returned, may be NULL.

Returns
  a 0 terminated array of sensor instance IDs or NULL on failure; call SDL_GetError() for more information. This should be freed with SDL_free() when it is no longer needed.

Since
  This function is available since SDL 3.2.0.

## SDL_GetSensorType()

SDL_SensorType SDL_GetSensorType | ( | SDL_Sensor * | sensor | ) |

extern

Get the type of a sensor.

Parameters

  sensor | the SDL_Sensor object to inspect.

Returns
  the SDL_SensorType type, or SDL_SENSOR_INVALID if sensor is NULL.

Since
  This function is available since SDL 3.2.0.

## SDL_GetSensorTypeForID()

SDL_SensorType SDL_GetSensorTypeForID | ( | SDL_SensorID | instance_id | ) |

extern

Get the type of a sensor.

This can be called before any sensors are opened.

Parameters

  instance_id | the sensor instance ID.

Returns
  the SDL_SensorType, or SDL_SENSOR_INVALID if instance_id is not valid.

Since
  This function is available since SDL 3.2.0.

## SDL_OpenSensor()

SDL_Sensor * SDL_OpenSensor | ( | SDL_SensorID | instance_id | ) |

extern

Open a sensor for use.

Parameters

  instance_id | the sensor instance ID.

Returns
  an SDL_Sensor object or NULL on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 3.2.0.

## SDL_UpdateSensors()

void SDL_UpdateSensors | ( | void |  | ) |

extern

Update the current state of the open sensors.

This is called automatically by the event loop if sensor events are enabled.

This needs to be called from the thread that initialized the sensor subsystem.

Since
  This function is available since SDL 3.2.0.